jQuery(function($){
// Configrations
var remoteUrl = 'http://smallseotools.com/';

// SEO Scores
var titlePoints = 5;
var slugPoints = 5;
var desPoints = 10;
var keywordsPoints = 5;
var wordsPointsLow = 10;
var wordsPointsMed = 15;
var wordsPointsHigh = 20;
var ratioPoints = 5;
var h1Points = 10;
var h2Points = 5;
var h3Points = 3;
var h4Points = 2;
var intLinksPoints = 5
var extLinksPointsLow = 5;
var extLinksPointsHigh = 10;
var imgsPoints = 5;
var brokenLinksPoints = 10;

// Animation Bar Pointing 
var totalbarval = 0;
var totalYellowbarval = 0;
var totalRedbarval = 0;
var animationRunning = 0;
var activeActions = 0;
var actionsComplete = 0;
var improvements = new Array();

// Configations & Data
var postText = '';
var postContent = '';
var previewHTML = '';
var accKey = '';
var accountOK = 1;

function sst_start_checking_main()
{
	addAnalyzeBtn();
	accKey = $("#sstMainAccKey").html();
	$("#AnalyzePost").click(function(){
		
		var plagBtn = $(this);
		if(plagBtn.hasClass("disable")){
			return false;
		}
		$("#sst_main_results").show();
		$("#statusImg").show();
		changeCstatus("Getting data from text editor...");
		
		$("#contentDetails").show();
		sstcheckSEO(accKey);										
		
		
		
	});
	$("#ddImpBtn").click(function(){
		$(".improvements").slideToggle(700);
		$(this).toggleClass("up");
	});
	
	$("#tabs a").click(function(){
		
		if(typeof $(this).attr("name") != 'undefined')
		{
			$(".tabsContent").hide();
			$("#" + $(this).attr("name")).show();
			$("#tabs li").removeClass("tab-current");
			$(this).parent().addClass("tab-current");
		}
	});
}
sst_start_checking_main();

function addAnalyzeBtn()
{
	// Start Analyze Button
	var htmlBtn = '<div class="sba_btnCheck_box">';
	htmlBtn += '<span class="button button-primary button-large sba_btnCheck" id="AnalyzePost">Check Plagiarism</span>';
	htmlBtn += '</div>'; 
	$("#major-publishing-actions").append(htmlBtn);
	// End Analyze Button
}




function sstcheckSEO(accountKey)
{
	if(!$("#wp-content-wrap").hasClass("tmce-active"))
	{
		alert("Please Select Visual Display in the text editor..")
		return false;
	}
	
	postContent = get_tinymce_content();				
	postText = postContent.replace(/(<([^>]+)>)/ig,"").replace(/\s+/g, " ");
	
	accKey = accountKey;
	
	windowScrolling();
	
	
	doAction(checkStatus);
	//doAction(getPreviewHtml);
	
	activeTab("contentStatus");
	
	
	doAction(checkSEO_step5);
}

function checkStatus()
{
	activeActions  = 1;
	
	$("#pluginStatus").html("");
	var key = $("#sstMainAccKey").html();
	var version = $("#sstPluginVersion").html();
	var plugDir = $("#sstpluginDir").html();
	var adminURL = $("#sstAdminURL").html();
	$.ajax({
		url : adminURL + "post.php",
		type: "post",
		data: {"key": key, "v":version, "sst_check_status": 1},
		dataType:"JSON",
		success: function(res){
			if(res.status != "ok")
			{
				var alertHTML = '<span class="alert alert_' + res.status + '">'
				+ res.msg
				+ '</span>';
				$("#pluginStatus").html(alertHTML)
				accountOK = 0;
			} else {
				accountOK = 1;
			}
			activeActions = 0;
		}
	});
	
}









function checkSEO_step5()
{
	hideCstatus();
	if(accKey.length < 10)
	{
		return false;
	}
	
	
	
	
	activeTab("sstplagResult");
	changeCstatus("Checking Post Plagiarism...");
	sendRequests(postText, accKey);
}


function activeTab(name){
	$("#tabs li").removeClass("tab-current");
	$(".tabsContent").hide();
	$("a[name='"+name+"']").parent().addClass("tab-current");
	$("#"+name).show();
}





function addStatus(type, title, content)
{
	var html = '<span class="notice ' + type + '"><p>'
               + '<b class="labelN">' + title + ' : </b><br>'
               +  content 
               +  '</p></span>';
	$("#contentStatus").append(html);
}






function get_tinymce_content(){
	if (jQuery("#wp-content-wrap").hasClass("tmce-active")){
		return tinyMCE.activeEditor.getContent();
	}else{
		return jQuery('#html_text_area_id').val();
	}
}

function getPreviewHtml()
{
	activeActions  = 1;
	changeCstatus("Getting data from Live Preview...");
	$.ajax({
		url: $("#post-preview").attr("href"),
		async:true,
		success: function(data)
		{
			previewHTML = data;
			activeActions  = 0;
		}
	});
}


function changeCstatus(val)
{
	$("#statusImg").show();
	$("#cStats").html(val);
}
function hideCstatus()
{
	$("#statusImg").hide();
	$("#cStats").html("");
}










function showAlert(type, msg)
{
	html = '<span class="alert alert_' + type + '">'
            + msg
            + '</span>';
	$("#alerts").html(html);
}




function windowScrolling()
{
	$("#sst-meta-box").removeClass("closed");
	var elemOff = $("#sst-meta-box").offset().top;
	elemOff = elemOff-100;
	activeActions = 1;
	$("html, body").animate({ scrollTop: elemOff }, 1000, function(){
		activeActions = 0;
	});
	
}

function doAction(fn)
{
		var interval = setInterval(function()
		{
			if(activeActions == 0)
			{
				clearInterval(interval);
				fn();
			}
		},100);
}










	
function get_hostname(url) {
    var m = url.match(/^http:\/\/[^/]+/);
	if(m)
	{
		return m[0];
	}
    var n = url.match(/^https:\/\/[^/]+/);
	if(n)
	{
		return n[0];
	}
	return null;
}


/// Plagiarism 

function sendRequests(innerText, accKey)
{
	var mainSite = remoteUrl;
	var plagBtn = $("#AnalyzePost");
	$("#plagResult").show();
	
	function doneRequests()
	{
		$("#loadGif").hide();
		plagBtn.removeClass("disable");
		$("#checkStatus").html("COMPLETE");
		$(".currentStatus").hide();
	}
	
	
	
	
	
	
	plagBtn.addClass("disable");
		
		
		$("#howUnique").show();
		$("#uniqueCount").html(0);
		var totalU = 0;
		$(".resultsBars").html("");
		$("#result-main").show();
		$("#loadGif").show();
		$("#checkStatus").html("Checking Content...");
		$("#plagResultsTsst").show();
		var parts = innerText.split(" ");
		var values = [];
		var i = 0;
		var tmpVar = "";
		var no = 1;
		$.each(parts, function(index, value) {
			
			if(tmpVar.length < 55)
			{
				tmpVar += " " + value;
			}else{
				values[i] = tmpVar.replace(/\s+/g, " ");
				i++;
				tmpVar = value;
			}
		});
		if(values.length < 1 &&  parts.length > 0) values[0] = tmpVar;
		
		var roundUnique = 0;
		var isPlagOnce = 0;
		var uparts = 100/values.length;
		uparts = parseFloat(uparts.toFixed(2));
		$("#uniqueBar").animate({"width" : "0%"}, 500);
		function doRequest(index) {
			plugDir = $("#sstpluginDir").html();
			var adminURL  = $("#sstAdminURL").html();
			$.ajax({
				type: 'POST',
				url : adminURL + "post.php",
				data : {"query" : values[index], "key" : accKey, "sst_check_plag" : 1},
				async:true,
				
				success: function(response){
					resp = JSON.parse(response);
					if(resp.error == "1")
					{
						errorHtml = '<span class="statBox plagSta">'
						+ '<span class="label label_warning">Account Authentication Error</span></span>';
						$(".resultsBars").append(errorHtml);
						doneRequests();
						return false;
					}
					if(resp.error == "2")
					{
						errorHtml = data.display1;
						$(".resultsBars").append(errorHtml);
						doneRequests();
						htmlIn = data.display2;
						showAlert("error", htmlIn);
						return false;
					}
					if(resp.data.unique == "true")
					{
						 alertHtml = '<span class="statBox uniqueSta">'
						+ '<span class="txt">' + values[index] + ' <b> - Unique</b></span>'
						+ '</span>';
		   
						
						totalU = totalU+uparts;
					}else {
						isPlagOnce = 1;
						 alertHtml = '<span class="statBox plagSta">'
						+ '<span class="txt">' + values[index] + ' <b>- plagiarized</b></span>'
						//+ '<textarea style="display:none;" id="ppscomData-'+index+'">'+response+'</textarea>'
						+ '<span class="check"><a class="button button-primary" style="color:#fff;" href="https://www.google.com/search?q=%22'+encodeURI(values[index])+'%22" target="_blank">Compare</a></span>';
					}
					
					$(".resultsBars").append(alertHtml);
					roundUnique = totalU.toFixed(0);
					$("#uniqueCount").html(roundUnique);
					$("#uniqueBar").animate({"width" : roundUnique+"%"}, 500);
					compareResults();
					
					if (index+1<values.length) {
						doRequest(index+1);
					}else{
						doneRequests();
						if(isPlagOnce != 1)
						{
							$("#uniqueCount").html(100);
							$("#uniqueBar").animate({"width" : "100%"}, 500);
						} else {
							if(roundUnique < 40)
							{
								htmlIn = '<b>Criticle Error Found: </b> Your Content is only <strong class="red">'+roundUnique+'% Unique</strong> this may hurt your page SEO, '
								+ 'Try to make it at least <strong class="green">65% Unique</strong>. You may acheive overall 100/100 SEO Score, but it will be useless '
								+ 'with out unique content. ';
								showAlert("error", htmlIn);
							} else if (roundUnique < 60) {
								htmlIn = '<b>Warning: </b> Your Content is only <strong class="red">'+roundUnique+'% Unique</strong> this may hurt your page SEO, '
								+ 'Try to make it at least <strong class="green">65% Unique</strong>. You may acheive overall 100/100 SEO Score, but it will be useless '
								+ 'with out unique content. ';
								showAlert("warning", htmlIn);
							}
						}
					}
				}
			}); 
		}
		if(values.length > 0){
			doRequest(0);
		}
}


	function compareResults()
	{
		$(".ppsCompare").click(function(){
			var idNo = $(this).attr("id").split("-")[1];
			var data = $("#ppscomData-"+idNo).val();
			$("#ppsCompareData").val(data);
			$("#ppsCompareForm").submit();
		});
	}

});